\ Xft fonts

Vocabulary xft

also dos

legacy off

also xft definitions

library libXft libXft.so

libXft XftFontMatch int int int int (int) XftFontMatch ( dpy screen pattern result -- pattern )
libXft XftFontOpenPattern int int (int) XftFontOpenPattern ( dpy pattern -- font )
libXft XftFontOpenXlfd int int int (int) XftFontOpenXlfd ( dpy screen xlfd -- font )
libXft XftXlfdParse int int int (int) XftXlfdParse ( xlfd igf compf -- pattern )
libXft XftTextExtents8 int int int int int (void) XftTextExtents8 ( dpy font string len extents -- )
libXft XftDrawCreate int int int int (int) XftDrawCreate ( dpy drawable visual colormap -- draw )
libXft XftDrawChange int int (void) XftDrawChange ( draw drawable -- )
libXft XftDrawDestroy int (void) XftDrawDestroy ( draw -- )
libXft XftDrawString8 int int int int int int int (void) XftDrawString8 ( d color font x y addr u -- )
libXft XftDrawString16 int int int int int int int (void) XftDrawString16 ( d color font x y addr u -- )
libXft XftDrawString32 int int int int int int int (void) XftDrawString32 ( d color font x y addr u -- )
libXft XftDrawStringUtf8 int int int int int int int (void) XftDrawStringUtf8 ( d color font x y addr u -- )
libXft XftDrawRect int int int int int int (void) XftDrawRect ( d color x y w h -- )
libXft XftColorAllocValue int int int int int (int) XftColorAllocValue ( d v cmap color result -- )
libXft XftColorFree int int int int (void) XftColorFree ( d v cmap color -- )
libXft XftDrawSetClip int int (int) XftDrawSetClip ( d r -- bool )

previous

0 Constant XftTypeVoid
1 Constant XftTypeInteger
2 Constant XftTypeDouble
3 Constant XftTypeString
4 Constant XftTypeBool
5 Constant XftTypeMatrix

struct{
    short red
    short green
    short blue
    short alpha
} XRenderColor

 struct{
    cell pixel
    struct XRenderColor color
} XftColor   

struct{
    double xx
    double xy
    double yx
    double yy
} XftMatrix

\ Create Xft0Matrix  $3FF00000. 2, 0. 2, 0. 2, $3FF00000. 2,
\ Create Xft90Matrix  0. 2, $3FF00000. 2, $3FF00000. 2, 0. 2,

struct{
    cell type
    {
        ptr s
|       cell i
|       cell b
|       double d
|       ptr m
    }
} XftValue

struct{
    ptr next
    struct XftValue value
} XftValueList

struct{
    ptr object
    ptr values
} XftPatternElt

struct{
    cell num
    cell size
    ptr elts
} XftPattern

struct{
    cell ascent
    cell descent
    cell height
    cell max_advance_width
    cell core
    ptr pattern
    ptr font
} XftFont

struct{
    short width
    short height
    short x
    short y
    short xOff
    short yOff
} XGlyphInfo

also minos definitions

X-font class Xft-font
how:
    | Variable xft-draw
    : assign ( addr u -- )
        name-string $!
        0 name-string $@ + c!
        screen xrc dpy @  screen xrc screen @
        name-string $@ drop XftFontOpenXlfd dup id !
        XftFont ascent @ ascent ! ;
    | Create text_r sizeof XGlyphInfo allot
    : size ( addr u -- w h )
        screen xrc dpy @ id @ 2swap text_r XftTextExtents8
        text_r XGlyphInfo width w@
        id @ dup XftFont ascent @ swap XftFont descent @ + ;
    | Create xft-color  sizeof XftColor allot
    $FFFF xft-color XftColor color XRendercolor alpha w!
    : draw ( addr u x y dpy -- ) { addr u x y dpy }
        color @ $FF and
        dpy displays with
            dup xrc color xft-color XftColor pixel !
            cells Colortable + @
            dup $FF and dup 8 lshift +
            [ xft-color XftColor color XRenderColor red ] ALiteral w! 8 >>
            dup $FF and dup 8 lshift +
            [ xft-color XftColor color XRenderColor green ] ALiteral w! 8 >>
            $FF and dup 8 lshift +
            [ xft-color XftColor color XRenderColor blue ] ALiteral w!
            drawable rot drop clip-r @
        endwith >r
        xft-draw @ 0= IF
            swap screen xrc vis @
            screen xrc cmap @ XftDrawCreate xft-draw !
        ELSE
            drop xft-draw @ swap XftDrawChange
        THEN
        xft-draw @ r> XftDrawSetClip drop
        xft-draw @ xft-color id @ x y ascent @ + addr u
        XftDrawString8
        xft-draw @ screen xwin @ XftDrawChange ;
class;

: xft-new-font  Xft-font new ;

' xft-new-font IS new-font

: replace-font ( addr u n -- )
    screen xrc fontarray @ @ over cells + off
    screen xrc font! ;
s" -xft-verdana-bold-r-normal--12-*-*-*-p-*-iso8859-15" 0 replace-font
s" -xft-courier-medium-r-normal--12-*-*-*-p-*-iso8859-15" 1 replace-font
s" -xft-verdana-medium-r-normal--8-*-*-*-p-*-iso8859-15" 2 replace-font
s" -xft-verdana-medium-r-normal--12-*-*-*-p-*-iso8859-15" 3 replace-font

previous previous forth definitions
